<?php
include_once $_SERVER['DOCUMENT_ROOT'] . '/include/shared-manual.inc';
$TOC = array();
$TOC_DEPRECATED = array();
$PARENTS = array();
include_once dirname(__FILE__) ."/toc/ref.outcontrol.inc";
$setup = array (
  'home' => 
  array (
    0 => 'index.php',
    1 => 'PHP Manual',
  ),
  'head' => 
  array (
    0 => 'UTF-8',
    1 => 'en',
  ),
  'this' => 
  array (
    0 => 'function.ob-list-handlers.php',
    1 => 'ob_list_handlers',
  ),
  'up' => 
  array (
    0 => 'ref.outcontrol.php',
    1 => 'Output Control Functions',
  ),
  'prev' => 
  array (
    0 => 'function.ob-implicit-flush.php',
    1 => 'ob_implicit_flush',
  ),
  'next' => 
  array (
    0 => 'function.ob-start.php',
    1 => 'ob_start',
  ),
  'alternatives' => 
  array (
  ),
  'source' => 
  array (
    'lang' => 'en',
    'path' => 'reference/outcontrol/functions/ob-list-handlers.xml',
  ),
  'history' => 
  array (
  ),
);
$setup["toc"] = $TOC;
$setup["toc_deprecated"] = $TOC_DEPRECATED;
$setup["parents"] = $PARENTS;
manual_setup($setup);

contributors($setup);

?>
<div id="function.ob-list-handlers" class="refentry">
 <div class="refnamediv">
  <h1 class="refname">ob_list_handlers</h1>
  <p class="verinfo">(PHP 4 &gt;= 4.3.0, PHP 5, PHP 7, PHP 8)</p><p class="refpurpose"><span class="refname">ob_list_handlers</span> &mdash; <span class="dc-title">List all output handlers in use</span></p>

 </div>

 <div class="refsect1 description" id="refsect1-function.ob-list-handlers-description">
  <h3 class="title">Description</h3>
  <div class="methodsynopsis dc-description">
   <span class="methodname"><strong>ob_list_handlers</strong></span>(): <span class="type"><a href="language.types.array.php" class="type array">array</a></span></div>

  <p class="para rdfs-comment">
   Lists all output handlers in use.
  </p>
 </div>


 <div class="refsect1 parameters" id="refsect1-function.ob-list-handlers-parameters">
  <h3 class="title">Parameters</h3>
  <p class="para">This function has no parameters.</p>
 </div>


 <div class="refsect1 returnvalues" id="refsect1-function.ob-list-handlers-returnvalues">
  <h3 class="title">Return Values</h3>
  <p class="para">
   This will return an array with the output handlers in use (if any).
  </p>
  <p class="para">
   If <a href="outcontrol.configuration.php#ini.output-buffering" class="link">output_buffering</a> is enabled
   and no <a href="outcontrol.configuration.php#ini.output-handler" class="link">output_handler</a> is set,
   or no callback or <strong><code><a href="reserved.constants.php#constant.null">null</a></code></strong> was passed to <span class="function"><a href="function.ob-start.php" class="function">ob_start()</a></span>,
   <code class="literal">&quot;default output handler&quot;</code> is returned.
   Enabling <a href="outcontrol.configuration.php#ini.output-buffering" class="link">output_buffering</a>
   and setting an <a href="outcontrol.configuration.php#ini.output-handler" class="link">output_handler</a>
   is equivalent to passing
   an <a href="functions.internal.php" class="link">internal (built-in) function</a>
   to <span class="function"><a href="function.ob-start.php" class="function">ob_start()</a></span>.
  </p>
  <p class="para">
   If a <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> was passed to <span class="function"><a href="function.ob-start.php" class="function">ob_start()</a></span>,
   the <a href="language.namespaces.basics.php" class="link">fully qualified name</a>
   of the <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> is returned.
   If the <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> is an object implementing
   <a href="language.oop5.magic.php#language.oop5.magic.invoke" class="link">__invoke()</a>,
   the <a href="language.namespaces.basics.php" class="link">fully qualified name</a>
   of the object&#039;s <a href="language.oop5.magic.php#language.oop5.magic.invoke" class="link">__invoke()</a>
   method is returned.
   If the <span class="type"><a href="language.types.callable.php" class="type callable">callable</a></span> is a <span class="classname"><a href="class.closure.php" class="classname">Closure</a></span>,
   <code class="literal">&quot;Closure::__invoke&quot;</code> is returned.
  </p>
 </div>


 <div class="refsect1 examples" id="refsect1-function.ob-list-handlers-examples">
  <h3 class="title">Examples</h3>
  <p class="para">
   <div class="example" id="example-624">
    <p><strong>Example #1 <span class="function"><strong>ob_list_handlers()</strong></span> example</strong></p>
    <div class="example-contents">
<div class="phpcode"><code><span style="color: #000000"><span style="color: #0000BB">&lt;?php<br /></span><span style="color: #FF8000">// using output_buffering=On, no output_handler set<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// no callback or null<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// anonymous function<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(function(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) { return </span><span style="color: #0000BB">$string</span><span style="color: #007700">; });<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// arrow function<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(fn(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) =&gt; </span><span style="color: #0000BB">$string</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// first class callable<br /></span><span style="color: #0000BB">$firstClassCallable </span><span style="color: #007700">= </span><span style="color: #0000BB">userDefinedFunction</span><span style="color: #007700">(...);<br /><br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">([</span><span style="color: #0000BB">$firstClassCallable</span><span style="color: #007700">, </span><span style="color: #DD0000">'__invoke'</span><span style="color: #007700">]);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// internal (built-in) function<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(</span><span style="color: #DD0000">'print_r'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// user-defined function<br /></span><span style="color: #007700">function </span><span style="color: #0000BB">userDefinedFunction</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">, </span><span style="color: #0000BB">$flags</span><span style="color: #007700">) { return </span><span style="color: #0000BB">$string</span><span style="color: #007700">; };<br /><br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(</span><span style="color: #DD0000">'userDefinedFunction'</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br />class </span><span style="color: #0000BB">MyClass </span><span style="color: #007700">{<br />    public static function </span><span style="color: #0000BB">staticHandle</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) {<br />        return </span><span style="color: #0000BB">$string</span><span style="color: #007700">;<br />    }<br /><br />    public static function </span><span style="color: #0000BB">handle</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) {<br />        return </span><span style="color: #0000BB">$string</span><span style="color: #007700">;<br />    }<br /><br />    public function </span><span style="color: #0000BB">__invoke</span><span style="color: #007700">(</span><span style="color: #0000BB">$string</span><span style="color: #007700">) {<br />        return </span><span style="color: #0000BB">$string</span><span style="color: #007700">;<br />    }<br />}<br /><br /></span><span style="color: #FF8000">// class and static method<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">([</span><span style="color: #DD0000">'MyClass'</span><span style="color: #007700">,</span><span style="color: #DD0000">'staticHandle'</span><span style="color: #007700">]);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// object and non-static method<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">([new </span><span style="color: #0000BB">MyClass</span><span style="color: #007700">,</span><span style="color: #DD0000">'handle'</span><span style="color: #007700">]);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /><br /></span><span style="color: #FF8000">// invokable object<br /></span><span style="color: #0000BB">ob_start</span><span style="color: #007700">(new </span><span style="color: #0000BB">MyClass</span><span style="color: #007700">);<br /></span><span style="color: #0000BB">var_dump</span><span style="color: #007700">(</span><span style="color: #0000BB">ob_list_handlers</span><span style="color: #007700">());<br /></span><span style="color: #0000BB">ob_end_flush</span><span style="color: #007700">();<br /></span><span style="color: #0000BB">?&gt;</span></span></code></div>
    </div>

    <div class="example-contents"><p>The above example will output:</p></div>
    <div class="example-contents screen">
<div class="examplescode"><pre class="examplescode">array(1) {
  [0]=&gt;
  string(22) &quot;default output handler&quot;
}
array(1) {
  [0]=&gt;
  string(22) &quot;default output handler&quot;
}
array(1) {
  [0]=&gt;
  string(7) &quot;print_r&quot;
}
array(1) {
  [0]=&gt;
  string(19) &quot;userDefinedFunction&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;Closure::__invoke&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;Closure::__invoke&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;Closure::__invoke&quot;
}
array(1) {
  [0]=&gt;
  string(21) &quot;MyClass::staticHandle&quot;
}
array(1) {
  [0]=&gt;
  string(15) &quot;MyClass::handle&quot;
}
array(1) {
  [0]=&gt;
  string(17) &quot;MyClass::__invoke&quot;
}</pre>
</div>
    </div>
   </div>
  </p>
 </div>


 <div class="refsect1 seealso" id="refsect1-function.ob-list-handlers-seealso">
  <h3 class="title">See Also</h3>
  <p class="para">
   <ul class="simplelist">
    <li><span class="function"><a href="function.ob-end-clean.php" class="function" rel="rdfs-seeAlso">ob_end_clean()</a> - Clean (erase) the contents of the active output buffer and turn it off</span></li>
    <li><span class="function"><a href="function.ob-end-flush.php" class="function" rel="rdfs-seeAlso">ob_end_flush()</a> - Flush (send) the return value of the active output handler
   and turn the active output buffer off</span></li>
    <li><span class="function"><a href="function.ob-get-flush.php" class="function" rel="rdfs-seeAlso">ob_get_flush()</a> - Flush (send) the return value of the active output handler,
   return the contents of the active output buffer and turn it off</span></li>
    <li><span class="function"><a href="function.ob-start.php" class="function" rel="rdfs-seeAlso">ob_start()</a> - Turn on output buffering</span></li>
   </ul>
  </p>
 </div>


</div><?php manual_footer($setup); ?>